@echo off
: Rem - %1 is the file to scan %2 is the name of the result file %3
: Rem - is the sentinel file. The report from the scan is sent to the
: Rem - Result file. If No virus is found then the Result file is
: Rem - deleted prior to deleting the sentinel file. If a virus, or
: Rem - other error is found, then a message indicating the meaning
: Rem - of the return code is tacked on to the end of the result
: Rem - file. Deletion of the sentinel file is the last thing that
: Rem - takes place.
: Rem - Note 1: Some of the error codes should never occur, in this
: Rem - context, but I put them in anyway for documentation purposes,
: Rem - if nothing else.
: Rem - Note 2: There's colons in front of the Rem statements because
: Rem - blank labels process faster than Rem statements (the entire
: Rem - Rem statement is parsed even though it's a comment)
: Rem - No extended batch command features are used so this should
: Rem - work with*any* MS OS.
: Rem - Watch for wrapping of the batch file lines in this email
: Rem - message.  They are longer that the normal 70 CPL!.  The
: Rem - F-PROT commandline and echo line should NOT be wrapped.


:rem PLEASE CONFIGURE VARIABLES BELOW!

: rem where lives F-Prot?
set fprot=c:\programme\fprot\F-prot.exe

: rem where live the Unixtools we need?
set unixutils=c:\programme\unixutils

: rem where to put the scratch files?
set scratch=c:\scratch

: rem where is the notification template?
: rem if it does not exist sender notification get's disabled
set template=c:\programme\mercury32\non-delivery.txt

: rem where is the notification template?
set blat=c:\programme\batches\blat.exe

: rem what's the postmaster e-mail address?
set postmaster=postmaster@example.com

: rem what SMTP password is set for the postmaster account?
set postpass=retsamtsop

:rem NoTHING TO CONFIGURE BELOW THIS LINE


echo scan: %1
echo result: %2
echo sentinel: %3

: rem call f-prot
%fprot% %1 /ARCHIVE=3 /SERVER /NOMEM /PACKED /REPORT=%2

echo f-prot scan finished
: rem pause

If Errorlevel 8 goto err8
If Errorlevel 7 goto err7
If Errorlevel 6 goto err6
If Errorlevel 5 goto err5
If Errorlevel 4 goto err4
If Errorlevel 3 goto err3
If Errorlevel 2 goto err2
If Errorlevel 1 goto err1

: rem all's well - delete result file
Del %2

goto Finished
:Err1
echo Abnormal termination - Unrecoverable Error >> %2
echo Internal error. English.tx0 or Sign.def or Macro.def missing/corrupted >> %2
goto Finished
:Err2
echo Selftest failed - program has been modified >> %2
goto Finished
:Err3
%unixutils%\grep Virus %2 > %scratch%\result-filt.txt
%unixutils%\grep Infection %2 | %unixutils%\gawk "// {sub(/.*\\/,\"\"); print;}" >> %scratch%\result-filt.txt

del %2
move %scratch%\result-filt.txt %2
echo !!!!!BOOT/FILE VIRUS FOUND!!!! >> %2

: rem sender
%unixutils%\grep -i return-path: %1 > %scratch%\scratch.tmp
%unixutils%\head -1 %scratch%\scratch.tmp > %scratch%\scratch2.tmp
%unixutils%\cut -d " " -f 2 %scratch%\scratch2.tmp > %scratch%\scratch.tmp
%unixutils%\sed "s/[<>]//g" %scratch%\scratch.tmp > %scratch%\tf.txt

: rem message headers
%unixutils%\sed "/^$/q" %1 > %scratch%\scratch.tmp

echo The message has NOT been delivered due to a VIRUS INFECTION! >> %2
echo. >> %2
echo ----- Start message headers ----- >> %2
echo. >> %2
type %scratch%\scratch.tmp >> %2
echo ----- End message headers ----- >> %2
echo. >> %2

: rem DISABLE "sender" notification IF notification template file is not present !!!
if exist %template% goto Notification
goto Finished

:Notification

: rem the windows "find" command sets an errorlevel, which we will use to skip
: rem "sender" notification for "known bad" virii - 0=found, 1=not found
find /I "Klez" %2
if not errorlevel 1 if errorlevel 0 goto Finished
find /I "Magistr" %2
if not errorlevel 1 if errorlevel 0 goto Finished
find /I "Bugbear" %2
if not errorlevel 1 if errorlevel 0 goto Finished
find /I "Sobig" %2
if not errorlevel 1 if errorlevel 0 goto Finished
find /I "MyDoom" %2
if not errorlevel 1 if errorlevel 0 goto Finished
find /I "NetSky" %2
if not errorlevel 1 if errorlevel 0 goto Finished


: rem send the notification
%blat% %template% -tf %scratch%\tf.txt -subject "Non-delivery notification" -attacht %2 -u postmaster -pw %postpass% -server 127.0.0.1 -f %postmaster%
echo sender notification finished
:rem pause

goto Finished
:Err4
echo !!VIRUS FOUND IN MEMORY!! >> %2
goto Finished
:Err5
echo Program terminated via ^C or Esc >> %2
goto Finished
:Err6
echo Virus removed >> %2
goto Finished
:Err7
echo Insufficient memory to run the program. >> %2
goto Finished
:Err8
echo *SUSPICIOUS* file found, no known infection >> %2
:Finished
: rem delete sentinel file
Del %3

echo policy job finished
: rem pause

exit
